#include "Source.h"
#include "Output.h"
#include <conio.h>
HANDLE m_hFile=NULL,mm_hFile=NULL;  
Output::Output(HRESULT *phr,Source *pParent):CSourceStream(NAME("Source"),phr,pParent,L"Source")
{
	m_pQutputQueue = NULL;
}

Output::~Output()
{
	if(m_pOutputQueue)
		delete m_pOutputQueue;
}
HRESULT Output::FillBuffer(IMediaSample *pms)
{
	BYTE *pData;   
    long lDataLen=0;   
    int i=0;
	if(m_hFile==NULL)   
    {   
		m_hFile = CreateFile(TEXT("F:\\xp\\TSOnly\\Anand_Sample_TS_mux1-cp_subtitle.ts"),   
                                        GENERIC_READ,   
                                        FILE_SHARE_READ,   
                                        NULL,   
                                        OPEN_EXISTING,   
                                        FILE_ATTRIBUTE_NORMAL,   
                                        NULL);   
       
        if(m_hFile == INVALID_HANDLE_VALUE )   
		{            
			m_hFile=NULL;   
			return E_FAIL;   
		}                
    }
	pms->GetPointer(&pData);
	lDataLen = pms->GetSize();   
	if(!ReadFile(m_hFile,pData,lDataLen,&lDataRead,NULL))   
	{
		m_hFile=NULL;   
		return 0;
	}
	if(lDataRead <= 0)   
		SetFilePointer(m_hFile,NULL,0,FILE_BEGIN);   
	pms->SetActualDataLength((long)lDataRead);
	return NOERROR;
}
HRESULT Output::DecideBufferSize(IMemAllocator *pIMemAllocator,ALLOCATOR_PROPERTIES *pProperties)
{
	CAutoLock cAutoLock(m_pFilter->pStateLock());
	ASSERT(pIMemAllocator);
	ASSERT(pProperties);
	HRESULT hr = NOERROR;
	pProperties->cBuffers = DIB_OUTPUTPIN_QUEUE_SIZE;
	pProperties->cbBuffer = DIB_TS_BUFFER_SIZE;
	ASSERT(pProperties->cbBuffer);   
	ALLOCATOR_PROPERTIES Actual;
	hr = pIMemAlloc->SetProperties(pProperties,&Actual);   
    if (FAILED(hr))
	{   
        return hr;   
    }   
    if (Actual.cbBuffer < pProperties->cbBuffer)
	{   
        return E_FAIL;   
    }   
    ASSERT( Actual.cBuffers == DIB_OUTPUTPIN_QUEUE_SIZE );   
    return NOERROR; 
}
HRESULT Output::CheckMediaType(const CMediaType *pMediaType)
{
	CAutoLock cAutoLock(m_pFilter->pStateLock());
	if (pMediaType->majortype != MEDIATYPE_Stream || pMediaType->subtype != MEDIASUBTYPE_MPEG2_TRANSPORT)
		return S_FALSE;
	return S_OK;
}
HRESULT Output::GetMediaType(int iPosition, CMediaType *pmt)
{
	CAutoLock cAutoLock(m_pFilter->pStateLock());
	if (iPosition < 0)
	{
		return E_INVALIDARG;
	}
	if(iPosition >=1)
	{
		return VFW_S_NO_MORE_ITEMS;
	}
	pmt->majortype = MEDIATYPE_Stream;
	pmt->subtype = MEDIASUBTYPE_MPEG2_TRANSPORT;
	pmt->formattype= FORMAT_None;
	return S_OK;
}
HRESULT Output::Active()
{
	CAutoLock lock_it(m_pLock);
	HRESULT hr = NOERROR;
	if (m_Connected && (m_pOutputQueue == NULL))
	{
		m_pOutputQueue = new COutputQueue(m_Connected, &hr, TRUE, FALSE);   
		if (m_pOutputQueue == NULL)
			return E_OUTOFMEMORY;
		if (FAILED(hr))   
		{
			delete m_pOutputQueue;
			m_pOutputQueue = NULL;
			return hr;
		}
	}
	return CSourceStream::Active();
}
HRESULT Output::Inactive()
{
	CAutoLock lock_it(m_pLock);
	if(m_pOutputQueue)
	{
		delete m_pOutputQueue;
		m_pOutputQueue = NULL;
	}
	return CSourceStream::Inactive();
}
HRESULT Output::Deliver(IMediaSample *pMediaSample)
{
	if (m_pOutputQueue == NULL)   
        return NOERROR;   
    pMediaSample->AddRef();   
    return m_pOutputQueue->Receive(pMediaSample); 
}
