#include "Source.h"
#include "SourceTypes.h"
#include <commctrl.h> 
#include "Output.h"
Source *Source::m_spSource=NULL;  
Source::Source(LPUnknow lpunk, HRESULT * phr):CSource(NAME("Source"),lpunk,CLSID_Source)
{
	CAutoLock cAutoLock(&m_cStateLock);
	*phr = E_FAIL;
	m_paStreams    = (CSourceStream **) new Output*[1];
	if (m_paStreams == NULL) 
	{   
		*phr = E_OUTOFMEMORY;   
		return;   
    }
	m_paStreams[0] = new TSOutputPin(phr, this); 
	if (m_paStreams[0] == NULL) 
	{
		*phr = E_OUTOFMEMORY; 
	}
	*phr = S_OK;
	return;
}
Source::~Source()   
{
	if(m_spSource)   
        m_spSource = NULL;   
} 
CUnknown * WINAPI Source::CreateInstance(LPUNKNOWN lpunk, HRESULT *phr)   
{   
    CUnknown *pUnkRet = NULL;   
    if(m_spSource)
	{
		*phr = E_FAIL;   
    }   
    else   
    {   
        m_spSource = new Source(lpunk, phr);   
        if (m_spSource == NULL  )    
            *phr = E_OUTOFMEMORY;   
        else   
        {   
            pUnkRet = m_spSource;   
           *phr = S_OK;   
        }   
    }   
    return pUnkRet;   
}
HRESULT Source::NonDelegatingQueryInterface(REFIID riid, void **ppv)
{	
    return CSource::NonDelegatingQueryInterface(riid, ppv);
}
STDMETHODIMP Source::Run(REFERENCE_TIME tStart)
{
	return CSource::RUN(tStart);
}
STDMETHODIMP Source::Stop()
{
	return CSource::Stop();
}
STDMETHODIMP Source::Pause()
{
	return CSource::Pause();
}